<template>
  <article class="article q-mb-xl" v-if="!loading">
    <section class="article__header column">
      <div class="article__navigation row items-center justify-between">
        <q-btn no-caps flat icon="arrow_back" style="padding-left: 0; color: #9fa1a8" @click="$router.go(-1)">
          Back
        </q-btn>
        <!-- <q-btn no-caps flat icon="more_horiz" style="color: #9fa1a8"> Categories </q-btn> -->
      </div>
      <div class="row items-center">
        <div class="article__user-panel q-mr-md">
          <img src="avatars/avatar.png" alt="" class="article__avatar q-mb-sm" />
        </div>
        <div class="row q-gutter-sm">
          <span :key="index" v-for="(category, index) in articleData.categories">
            {{ category }}
          </span>
        </div>
      </div>
      <div class="row items-start">
        <div
          class="column justify-center items-center article__likes cursor-pointer"
          style=""
          @click="!isLiked ? like() : ''"
          :class="{ article__likes_liked: isLiked }"
        >
          <img src="~assets/svg/like.svg" alt="" />
          <span class="text-h4"> {{ articleData.likes }}</span>
        </div>
        <h1 class="q-ml-md text-h1">{{ articleData.title }}</h1>
      </div>
      <div class="row">
        <q-btn flat no-caps class="row" style="margin-left: 96px" @click="scrollIntoComments()">
          <img class="q-mr-sm" src="~assets/svg/comments.svg" alt="" />
          <span style="color: #9fa1a8" class="text-subtitle1">{{ articleData.comments?.length }} comments</span>
        </q-btn>
        <q-btn flat no-caps class="row q-ml-md cursor-pointer">
          <img class="q-mr-sm" src="~assets/svg/share.svg" alt="" />
          <span @click="shareArticleDialog.show()" style="color: #9fa1a8" class="text-subtitle1">Share</span>
        </q-btn>
      </div>
    </section>
    <section class="article__body">
      <div class="q-mt-xl col-12 column">
        <span class="text-body1" style="color: #9fa1a8">
          {{ articleData.description }}
        </span>
        <q-img class="full-width q-my-sm" :src="`http://localhost:3000/${articleData.preview_img_path}`" alt="no way" />
      </div>
      <div class="article__content text-body1 col-12" style="color: #9fa1a8" v-html="articleData.content" />
      <div class="section flex justify-end q-gutter-x-sm q-mt-lg">
        <q-btn
          :dense="$q.screen.lt.sm"
          unelevated
          color="primary"
          text-color="secondary"
          label="Set to showcase"
          @click="setShowcase()"
          v-if="isLoggedIn"
        />
        <q-btn
          :dense="$q.screen.lt.sm"
          unelevated
          color="primary"
          text-color="secondary"
          icon="delete"
          label="Delete Article"
          @click="deleteArticle(articleData.id)"
          v-if="isLoggedIn"
        />
      </div>
      <section ref="commentsSection" class="article__comments article-comments col-12 column q-mt-lg">
        <div class="article-comments__count q-mb-md">
          <span> {{ articleData.comments?.length }} Comments</span>
        </div>
        <div class="article-comments__write q-gutter-y-md">
          <q-input
            v-model="newCommentAuthor"
            type="text"
            :label="`Your name`"
            outlined
            class="default-input article-comments__reply-input_author"
            style="font-size: 14px"
            autogrow
          />
          <q-input
            v-model="newComment"
            type="text"
            label="Leave a comment"
            outlined
            class="default-input article-comments__input"
            style="font-size: 18px"
            autogrow
          />
          <div class="row justify-end">
            <q-btn
              :dense="$q.screen.lt.sm"
              unelevated
              color="primary"
              text-color="secondary"
              icon="create"
              label="Submit"
              @click="leaveComent(newComment)"
            />
          </div>
        </div>
        <div class="article-comments__list q-gutter-y-sm">
          <div
            class="article-comments__comment article-comment column"
            :id="comment.id"
            :key="index"
            v-for="(comment, index) in headComments"
          >
            <div class="q-mb-xs text-caption">
              <span>{{ comment.author }}</span>
              <span v-if="!comment.deleted" class="q-ml-md">
                {{ calcTimeAgo(new Date(comment.published_at)) + " ago" }}
              </span>
            </div>
            <div class="q-mb-xs text-body2">
              <span>{{ comment.content }}</span>
            </div>
            <div class="flex justify-end">
              <q-btn
                dense
                no-caps
                flat
                style="color: #9fa1a8"
                icon="delete"
                label=""
                @click="deleteComment(comment.id)"
                v-if="!comment.deleted && isLoggedIn"
              />
              <q-btn v-if="!comment.deleted" dense no-caps flat style="color: #9fa1a8" @click="replyTo(comment)">
                Reply
              </q-btn>
            </div>
            <div class="q-ml-xl" v-if="comment.hasChilds">
              <div
                class="article-comments__comment article-comment column"
                :id="childComment.id"
                :key="childIndex"
                v-for="(childComment, childIndex) in comment.childs"
              >
                <div class="q-mb-xs text-caption">
                  <span>{{ childComment.author }}</span>
                  <span v-if="!childComment.deleted" class="q-ml-md">
                    {{ calcTimeAgo(new Date(childComment.published_at)) + " ago" }}</span
                  >
                </div>
                <div class="q-mb-xs text-body2">
                  <button class="q-mr-xs reply-name-button" @click="scrollIntoId(childComment.parent_id)">
                    {{ `@${articleData.comments.filter((value) => value.id === childComment.parent_id)[0].author}` }}
                  </button>
                  <span>{{ childComment.content }}</span>
                </div>
                <div class="flex justify-end">
                  <q-btn
                    dense
                    no-caps
                    flat
                    style="color: #9fa1a8"
                    icon="delete"
                    label=""
                    @click="deleteComment(childComment.id)"
                    v-if="!childComment.deleted && isLoggedIn"
                  />
                  <q-btn
                    v-if="!childComment.deleted"
                    dense
                    no-caps
                    flat
                    style="color: #9fa1a8"
                    @click="replyTo(childComment)"
                  >
                    Reply
                  </q-btn>
                </div>
              </div>
            </div>
            <div class="q-ml-xl column q-gutter-y-md q-mt-sm" v-if="comment.replyInputVisibility">
              <q-input
                v-model="newCommentAuthor"
                type="text"
                :label="`Your name`"
                outlined
                class="default-input article-comments__reply-input_author"
                style="font-size: 14px"
                autogrow
              />
              <q-input
                ref="replyInput"
                v-model="newReplyComment"
                type="text"
                :label="`Reply to ${currentReplyComment.author}`"
                outlined
                class="default-input article-comments__reply-input"
                style="font-size: 14px"
                autogrow
              />
              <div class="row justify-end">
                <q-btn
                  :dense="$q.screen.lt.sm"
                  unelevated
                  color="primary"
                  text-color="secondary"
                  icon="create"
                  label="Submit"
                  @click="leaveComent(newReplyComment, currentReplyComment.id)"
                />
              </div>
            </div>
          </div>
        </div>
      </section>
    </section>

    <q-dialog ref="shareArticleDialog">
      <q-card dark>
        <q-card-section>
          <div class="text-h2">Share to your friends</div>
        </q-card-section>

        <q-card-section class="q-pt-none"> </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </article>
  <div v-else class="flex justify-center items-center">
    <q-spinner color="primary" size="200px"> </q-spinner>
  </div>
</template>

<script setup>
import {
  getFullArticle as _getFullArticle,
  deleteArticle as _deleteArticle,
  setShowcase as _setShowcase,
  like as _like,
} from "../services/articleService";
import { ref, computed, onMounted, watch } from "vue";
import { useStore } from "vuex";
import { useRoute, useRouter } from "vue-router";
import {
  leaveComent as _leaveComment,
  getComments,
  deleteComment as _deleteComment,
} from "../services/commentsService";
const router = useRouter();
const store = useStore();
const isLoggedIn = computed(() => store.getters["userModule/isLoggedIn"]);
const route = useRoute();
const articleData = ref({ comments: [] });
const loading = ref(false);
const commentsSection = ref(null);
const shareArticleDialog = ref(false);
const newCommentAuthor = ref("");
const currentReplyComment = ref("");
const headComments = ref([]);
const newComment = ref("");
const newReplyComment = ref("");
const replyInput = ref("");
const isLiked = ref(false);

async function deleteComment(commentId) {
  const result = await _deleteComment(commentId);
  if (result) {
    articleData.value.comments = await getComments(articleData.value.id);
  }
}
async function setShowcase() {
  const result = await _setShowcase(articleData.value.id);
}

function replyTo(replyComment) {
  headComments.value = headComments.value.map((comment) => {
    comment.replyInputVisibility = false;
    if (comment.id === replyComment.id) {
      comment.replyInputVisibility = true;
    }
    comment.childs.forEach((child) => {
      if (child.id === replyComment.id) {
        comment.replyInputVisibility = true;
      }
    });
    return comment;
  });
  currentReplyComment.value = replyComment;
  replyInput.value.scrollIntoView({ behavior: "smooth" });
}
async function getFullArticle(slug) {
  loading.value = true;
  const article_data = await _getFullArticle(slug);
  loading.value = false;
  return article_data;
}
async function leaveComent(value, parentCommentId) {
  newReplyComment.value = "";
  newComment.value = "";
  // submit comment, get new comments
  await _leaveComment(articleData.value.id, parentCommentId, newCommentAuthor.value, value);
  articleData.value.comments = await getComments(articleData.value.id);
  newComment.value = "";
}

watch(
  () => articleData.value.comments,
  async (newComments, oldComments) => {
    if (!newComments) {
      return;
    }
    let hComments = newComments.map((comment, index, comments) => {
      function findChilds(comment) {
        let childs = [];
        childs = comments.filter((possibleChildComment) => possibleChildComment.parent_id === comment.id);

        childs.forEach((comment) => {
          let newChilds = findChilds(comment);
          childs.push(...newChilds);
        });
        return childs;
      }
      if (comment.parent_id === null) {
        comment.childs = findChilds(comment);
        comment.hasChilds = true;
        comment.replyInputVisibility = false;

        return comment;
      }
    });
    hComments = hComments.filter((value) => {
      if (!value) {
        return false;
      }
      return true;
    });
    headComments.value = hComments;
  }
);

async function deleteArticle(articleId) {
  const result = await _deleteArticle(articleId);
  if (result) {
    router.push({ name: "Index" });
  }
}
async function like() {
  const success = await _like(articleData.value.id);
  if (!success) {
    return;
  }
  articleData.value.likes = articleData.value.likes + 1;
  isLiked.value = true;
  if (!localStorage.getItem("likes")) {
    localStorage.setItem("likes", articleData.value.id);
  } else {
    localStorage.setItem("likes", `${localStorage.getItem("likes")},${articleData.value.id}`);
  }
}

function scrollIntoComments() {
  commentsSection.value.scrollIntoView({ behavior: "smooth" });
}
function scrollIntoId(id) {
  const commentEl = document.getElementById(id);
  commentEl.scrollIntoView({ behavior: "smooth" });
}
function calcTimeAgo(date) {
  var seconds = Math.floor((new Date() - date) / 1000);
  var intervalType;

  var interval = Math.floor(seconds / 31536000);
  if (interval >= 1) {
    intervalType = "year";
  } else {
    interval = Math.floor(seconds / 2592000);
    if (interval >= 1) {
      intervalType = "month";
    } else {
      interval = Math.floor(seconds / 86400);
      if (interval >= 1) {
        intervalType = "day";
      } else {
        interval = Math.floor(seconds / 3600);
        if (interval >= 1) {
          intervalType = "hour";
        } else {
          interval = Math.floor(seconds / 60);
          if (interval >= 1) {
            intervalType = "minute";
          } else {
            interval = seconds;
            intervalType = "second";
          }
        }
      }
    }
  }

  if (interval > 1 || interval === 0) {
    intervalType += "s";
  }

  return interval + " " + intervalType;
}

onMounted(() => {
  getFullArticle(route.params.slug).then((article_data) => {
    articleData.value = article_data;
    const articleLikes = localStorage.getItem("likes").split(",");
    console.log("artLikes:", articleLikes);
    if (articleLikes.find((el) => el == article_data.id)) {
      isLiked.value = true;
    }
    console.log(isLiked.value);
  });
});
</script>

<style lang="scss" scoped>
.article {
  width: 100%;
  &__likes {
    border: 2px grey solid;
    border-radius: 8px;
    width: 80px;
    height: 80px;
    color: #d8d9df;
    &_liked {
      background-color: rgba(255, 255, 255, 0.1);
      border-color: #fec367;
    }
  }
  &__header {
    padding-bottom: 22px;
    padding-left: 15.27vw;
    padding-right: 15.27vw;
    background-color: #272930;
  }
  &__navigation {
    height: 75px;
    border-bottom: #3f424e solid 1px;
  }
  &__user-panel {
    padding-top: 22px;
  }
  &__body {
    padding-left: 15.27vw;
    padding-right: 15.27vw;
    @media (max-width: 600px) {
      padding-left: 0;
      padding-right: 0;
    }
  }
  :deep(.article__content) {
    img {
      width: 100%;
      margin-top: 8px;
      margin-bottom: 8px;
    }
  }
  .article-comments {
    :deep(.article-comments__input) {
      background-color: #2e3138;
      .q-field__native {
        min-height: 91px !important;
      }
    }
    :deep(.article-comments__reply-input) {
      background-color: #2e3138;
      .q-field__native {
        min-height: 63px !important;
      }
    }
    :deep(.article-comments__reply-input_author) {
      background-color: #2e3138;
    }
    &__list {
      padding-left: 4.58vw;
      padding-right: 4.58vw;
    }
    .article-comment {
      color: #9fa1a8;
    }
    .reply-name-button {
      background-color: transparent;
      color: currentColor;

      border-radius: 4px;
      padding: 1px 4px;
      &:hover,
      &:focus {
        background-color: rgba(104, 104, 104, 0.356);
        animation-name: fadeInColor;
        animation-duration: 0.4s;
      }
      @keyframes fadeInColor {
        from {
          background-color: transparent;
        }

        to {
          background-color: rgba(104, 104, 104, 0.356);
        }
      }
    }
  }
}
</style>
